<template>
    <p>{{ appConnected }}</p>
</template>

<script>
import io from 'socket.io'
export default {
  data: () => ({
    appConnected: [],
    ioServer: {}
  }),
  created () {
    this.socketServerOn()
  },
  methods: {
    socketServerOn () {
      let sequenceNumberByClient = new Map()
      this.ioServer = io.listen(8080)
      this.ioServer.on('connection', (socket) => {
        console.info(`Client connected [id=${socket.id}]`)
        this.appConnected.push(`Client connected [id=${socket.id}]`)
    // initialize this client's sequence number
        sequenceNumberByClient.set(socket, 1)

    // when socket disconnects, remove it from the list:
        socket.on('disconnect', () => {
          sequenceNumberByClient.delete(socket)
          console.info(`Client gone [id=${socket.id}]`)
          this.appConnected.push(`Client gone [id=${socket.id}]`)
        })
      })
// sends each client its current sequence number
      setInterval(() => {
        for (const [client, sequenceNumber] of sequenceNumberByClient.entries()) {
          client.emit('seq-num', sequenceNumber)
          sequenceNumberByClient.set(client, sequenceNumber + 1)
        }
      }, 1000)
    }
  }
}
</script>

<style>

</style>
